/**
******************************************************************************
* @file    CX800S.c
* @author  CWX Application Team
* @version V1.0
* @date    07-September-2018
* @brief   
******************************************************************************
* @attention
*
* <h2><center>&copy; COPYRIGHT 2018 Ψо</center></h2>
*
******************************************************************************
*/
/* Includes ------------------------------------------------------------------*/

/********************************************************************************************
*                                                                                           *
*                                                                                   *
*                                                                                           *
*********************************************************************************************
*/
/*************************************************************
//            MP3沥
//
// CX800S_Send(CMD_MP3,DATA_MP3_PLY);//
*/
#define 	    CMD_MP3                    0x11

#define        DATA_MP3_PLY              1  //
#define        DATA_MP3_BREAK            2  //ͣ
#define        DATA_MP3_STOP             3  //ֹͣ
#define        DATA_MP3_NEXT             4  //һ
#define        DATA_MP3_PREV             5  //һ
#define        DATA_MP3_VOLADD           6  //
#define        DATA_MP3_VOLDEC           7  //
#define        DATA_MP3_INTSTOP          8  //岥ֹͣ

/*************************************************************
//            ָļŲ
˵ļ3λʽ001-xxxx.mp3002-xxxx.mp3003-xxxx.mp3
ļΪ001-Ψоӭ.mp3Ϊ1.
    CX800S_Send(CMD_PLY_NAME_NUN,1);
*/
//
#define 		CMD_PLY_NAME_NUN           0x12 
//ϲţϲţ
#define 		CMD_COMBINE_NAME_NUM       0x13  //CMD_CYC0x18Ϊ4ֹͣϵĬģʽЧ
//ѭָĿ
#define 		CMD_LOOP_NAME_NUM          0x14  //CMD_CYC0x18Ϊ4ֹͣϵĬģʽЧ
//岥ϵǰţ󷵻ԭţ
#define 		CMD_IPLY_NUM_NUM           0x15  //

/*************************************************************
//            
˵0~30
  CX800S_Send(CMD_VOL,25);//25
*/
#define 		CMD_VOL                    0x16

#define         DATA_VOL_MAX               30

/*************************************************************
//            豸ѡ
˵ѡ񲥷豸:flashCX800SCX850S
SD/TF (CX830S,CX850S)
U   CX800S,CX830S,CX850S
*/
#define 		CMD_DEV                    0x17

#define         DATA_DEV_UDish             0  //U
#define         DATA_DEV_SD                1  //SD/TF
#define         DATA_DEV_FLASH             2  //FLASH

/*************************************************************
//            ѭģʽѡ
˵ȫѭ洢豸Ƶѭţ
ѭѭͬһĿ
ļѭѭŵǰļĿ
ţ洢Ƶţ
ֹͣϵĬϣһĿֹͣ
˳򲥷ţ洢Ƶֹͣ
*/
#define 		CMD_CYC                    0x18

#define         DATA_CYC_ALL               0  //ȫѭ
#define         DATA_CYC_SINGLE_ROOP       1  //ѭ
#define         DATA_CYC_FOLDER            2  //ļѭ
#define         DATA_CYC_RAND              3  //
#define         DATA_CYC_SINGLE            4  //ֹͣ
#define         DATA_CYC_ORDER             5  //˳򲥷


/*************************************************************
//            ָļ
˵ļ˳ţһصļΪ1
ط ļ3λʽ001-xxxx.mp3002-xxxx.mp3003-xxxx.mp3
ȫѡļŵһļһƣճ洢̷Уô˳͸ļ˳һһӦ
CX800S_Send(CMD_PLY_INDEX,1);
*/
//
#define 		CMD_PLY_INDEX              0x19
//ϲţϲţ
#define 		CMD_COMBINE_INDEX          0x1a //CMD_CYC0x18Ϊ4ֹͣϵĬģʽЧ
//ѭָĿ
#define 		CMD_LOOP_INDEX             0x1b //CMD_CYC0x18Ϊ4ֹͣϵĬģʽЧ
//岥ϵǰţ󷵻ԭţ
#define 		CMD_IPLY_INDEX             0x1c

/*************************************************************
//            ŽϢ
˵òŽǷжϢĬϹر
CX800S_Send(CMD_END_MSG_EN,DATA_END_MSG_ON);//Žж
*/
#define 		CMD_END_MSG_EN             0x1d

#define 		DATA_END_MSG_ON              1  //
#define 		DATA_END_MSG_OFF             0  //ر
/********************************************************************************************
*                                                                                           *
*                                        ѯ                                           *
*                                                                                           *
*********************************************************************************************
*/
/*************************************************************
//            ȡ״̬Ĵ
//˵״̬Ĵ仯ʱжϣDI/INTɵ͵ƽ֪ͨȡ״̬Ĵ
ȡ״̬Ĵ󣬴־λ4λԶ㣬DI/INTߵƽ
豸仯ʱ豸߰γҲж
// u8 status = CX800S_Send(READ_STATUS,0);
*/

#define 	READ_STATUS                0x80

#define     BIT(n)                 (1<<n)
#define 	STATUS_BIT_BUSY               BIT(0)     //æڲӦʱϢpcʱ岥ʱͨ
#define 	STATUS_BIT_DEV_ERR            BIT(1)	 //豸ûв豸豸޲ļ
#define 	STATUS_BIT_FILE_ERR           BIT(2)	 //ļ
#define 	STATUS_BIT_END                BIT(3)	 //ŽCMD_END_MSG_EN0x1d
#define 	STATUS_BIT_PC_ONLINE          BIT(4)	 //ӵԱ־λ0δ  1
#define 	STATUS_BIT_SD_ONLINE          BIT(5)     //SD߱־λ0δ  1
#define 	STATUS_BIT_UDISH_ONLINE       BIT(6)	 //U߱־λ 0δ  1
#define 	STATUS_BIT_FLASH_ONLINE       BIT(7)     //Flash߱־λ0δ  1

/*************************************************************
//            ȡ״̬Ĵ
//˵
// u8 state = CX800S_Send(READ_STATE,0);
*/
#define 	READ_STATE                 0x81

#define     STATE_PLAY                 0  // 
#define     STATE_BREAK                1  // ͣ
#define     STATE_STOP                 2  // ֹͣ

/*************************************************************
//            ȡǰĿ
//˵Index˳˳
// u8 Index = CX800S_Send(READ_CUR_INDEX,0);
*/
#define 	READ_CUR_INDEX             0x82

/*************************************************************
//            ȡǰ
//˵0~30
// u8 Volume = CX800S_Send(READ_VOL,0);
*/
#define 	READ_VOL                   0x84
/*************************************************************
//            ȡǰ豸
//˵
// u8 Dev = CX800S_Send(READ_DEV,0);
*/
#define 	READ_DEV				   0x86

#define         DEV_UDish             0  //U
#define         DEV_SD                1  //SD/TF
#define         DEV_FLASH             2  //FLASH

/*************************************************************
//            ȡǰѭģʽ
//˵
// u8 CycMode = CX800S_Send(READ_CYC,0);
*/
#define 	READ_CYC				   0x87

#define         CYC_ALL               0  //ȫѭ
#define         CYC_SINGLE_ROOP       1  //ѭ
#define         CYC_FOLDER            2  //ļѭ
#define         CYC_RAND              3  //
#define         CYC_SINGLE            4  //ֹͣ
#define         CYC_ORDER             5  //˳򲥷

/*************************************************************
//            ȡļ
//˵0~255
// u8 Total = CX800S_Send(READ_TOTAL_FILE,0);
*/
#define 	READ_TOTAL_FILE            0x88



/********************************************************************************************
*                                                                                           *
*                              funtion                                                      *
*                                                                                           *
*********************************************************************************************
*/
/*************************************************************
//            Port
//˵ֲIO
*/
#ifndef u8
#define u8    unsigned char
#endif

#define   CLK_L()          //clk =0
#define   CLK_H()          //clk =1

#define   DO_L()          //DO =0
#define   DO_H()          //DO =1

#define   READ_DI()          1//DI
//ʱ
#define  delayms(m)         //ʱ룺m*1ms
#define  delayus(u)         //ʱ΢룺u*1us

/*************************************************************
//            u8 CX800S_Send(u8 cmd,u8 data)
//˵CX800S,CX830S,CX850SͨãȡĴ
*/

u8 CXError=0;
u8 Cx800sStatus=0;
u8 CX800S_Send(u8 cmd, u8 data)
{
	u8 Rx = 0;
	u8 temp;
	u8 i;
	CLK_L();
	delayms(5);
	temp = cmd;
	for (i = 0; i < 8; i++) {
		Rx >>= 1;
		if (temp & 0x01) {
			DO_H();
		}
		else {
			DO_L();
		}

		delayus(200);

		CLK_H();

		delayus(200);
		CLK_L();
		if (READ_DI())
			Rx |= 0x80;
		temp >>= 1;
	}
	if (Rx != cmd) {
		CXError++;
		return 0xff;//error
	}
	Rx = 0;
	delayus(200);
	temp = data;
	for (i = 0; i < 8; i++) {
		Rx >>= 1;

		if (temp & 0x01) {
			DO_H();
		}
		else {
			DO_L();
		}

		delayus(200);

		CLK_H();

		delayus(200);
		CLK_L();
		if (READ_DI())
			Rx |= 0x80;
		temp >>= 1;

	}
	if (((cmd & 0x80) == 0) && (Rx != data)) {
		CXError++;
		return 0xff;//error
	}
	delayus(200);
	CLK_H();
	delayus(200);
	//delayms(5);
	return Rx;
}
/*************************************************************
//            u8 CX800S_Intrrupt(void)
//˵CX800S,CX830S,CX850Sͨã
*/
u8 CX800S_Intrrupt(void)
{
	return (!READ_DI());//ϢʱDIΪ͵ƽ
}
/*************************************************************
//            u8 CX800S_Exec(void)
//˵CX800S,CX830S,CX850SͨãCX800S 豸仯
*/
void CX800S_Exec(void)
{
		u8 status,temp;
		if (CX800S_Intrrupt()) 
		{
			 status = CX800S_Send(READ_STATUS,0);
			 if(status&0xf){//
					 if(status&STATUS_BIT_BUSY)
					 {
					 //æ
					 }
					 if(status&STATUS_BIT_DEV_ERR)
					 {
					 //豸޲ļ
					 }
					 if(status&STATUS_BIT_FILE_ERR)
					 {
						 //ļ
					 }
					 if(status&STATUS_BIT_END)
					 {
						 //Ž
					 }
		   }
			 temp = status^Cx800sStatus;
			 temp &= 0xf0;
			 
			 if(temp){//豸仯
					 if(temp&STATUS_BIT_PC_ONLINE)
					 {
					    if(status&STATUS_BIT_PC_ONLINE)
							{
							//豸
							}else
							{
							//豸γ
							}
					 }
//					 if(temp&STATUS_BIT_SD_ONLINE)
//					 {
//					    if(status&STATUS_BIT_SD_ONLINE)
//							{
//								//SD
//							}else
//							{
//							//SDγ
//							}
//					 }
					 if(temp&STATUS_BIT_UDISH_ONLINE)
					 {
					    if(status&STATUS_BIT_UDISH_ONLINE)
							{
							//U̲
							}else
							{
							//Ṵγ
							}
					 }
					 if(temp&STATUS_BIT_FLASH_ONLINE)
					 {
					    if(status&STATUS_BIT_FLASH_ONLINE)
							{
							//Flash
							}else
							{
							//No Flash
							}
					 }
		   }
			 Cx800sStatus = status;
		}

}
